Index: trunk/source/Lib/TLibRenderer/TRenTop.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenTop.cpp	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenTop.cpp	(revision 608)
@@ -32,4 +32,5 @@
  */
 
+
 #include "TRenImage.h"
 #include "TRenTop.h"
@@ -39,4 +40,6 @@
 #include <math.h>
 #include "../TLibCommon/CommonDef.h"
+#if H_3D
+
 
 Void TRenTop::xGetDataPointers( PelImage*& rpcInputImage, PelImage*& rpcOutputImage, PelImage*& rpcInputDepth, PelImage*& rpcOutputDepth, PelImage*& rpcFilled, Bool bRenderDepth )
@@ -1030,4 +1033,22 @@
             for ( ; iInterPolPos <= xCeil (iShiftedPos ) -1 ; iInterPolPos++)
             {
+#if H_3D_FIX_REN
+              if ( ( iInterPolPos >= 0 ) && ( iInterPolPos < iOutputWidth ) )
+              {
+                if( pcFilledData[iInterPolPos] == REN_IS_HOLE )
+                {               
+                  Int iNextPos = std::min(iInputWidth-1,iPosX + iStep); 
+                  Int iPosXBG  = ( std::abs( pcDepthData[iNextPos] - pcDepthData[iPosX] ) > 5  ) ? iPosX : iNextPos; 
+                  for( UInt uiCurPlane = 0; uiCurPlane < uiNumberOfPlanes; uiCurPlane++)
+                  {
+                    apcOutputData[uiCurPlane][iInterPolPos]  = apcInputData[uiCurPlane][iPosXBG];
+                  }
+                }
+                else
+                {
+                  pcFilledData[iInterPolPos] = REN_IS_HOLE + 1; 
+                }
+              }
+#else
               for( UInt uiCurPlane = 0; uiCurPlane < uiNumberOfPlanes; uiCurPlane++)
               {
@@ -1037,4 +1058,5 @@
                 }
               }
+#endif
             }
           }
@@ -1282,5 +1304,9 @@
         else
         {
+#if H_3D_FIX_REN
+          pcAlphaData[iXPos] = pcFilledData[iXPos];
+#else
           pcAlphaData[iXPos] = REN_IS_FILLED;
+#endif
         }
       }
@@ -1588,15 +1614,16 @@
 Void TRenTop::xEnhSimilarityPlane       ( PelImagePlane** apcLeftPlane, PelImagePlane** apcRightPlane, PelImagePlane* pcFilledLeftPlane, PelImagePlane* pcFilledRightPlane, UInt uiNumberOfPlanes )
 {
+  AOF( g_bitDepthC == g_bitDepthY ); 
   AOT( m_iSimEnhBaseView != 1 && m_iSimEnhBaseView != 2 );
   Int iWidth  = (*apcRightPlane)->getWidth ();
   Int iHeight = (*apcRightPlane)->getHeight();
 
-  Int* aiHistLeft  = new Int[ g_uiIBDI_MAX + 1 ];
-  Int* aiHistRight = new Int[ g_uiIBDI_MAX + 1 ];
-  Pel* aiConvLUT   = new Pel[ g_uiIBDI_MAX + 1 ];
+  Int* aiHistLeft  = new Int[ ((Int64)1 ) << g_bitDepthY ];
+  Int* aiHistRight = new Int[ ((Int64)1 ) << g_bitDepthY ];
+  Pel* aiConvLUT   = new Pel[ ((Int64)1 ) << g_bitDepthY ];
 
   for (UInt uiCurPlane = 0; uiCurPlane < uiNumberOfPlanes; uiCurPlane++ )
   {
-    for (Int iCurVal = 0 ; iCurVal <= g_uiIBDI_MAX; iCurVal++)
+    for (Int iCurVal = 0 ; iCurVal < ( 1 << g_bitDepthY ); iCurVal++)
     {
       aiHistLeft [iCurVal] = 0;
@@ -1645,5 +1672,5 @@
     Int iCheckSumRight = 0;
 
-    for (Int iCurVal = 0 ; iCurVal <= g_uiIBDI_MAX; iCurVal++)
+    for (Int iCurVal = 0 ; iCurVal < ( 1 << g_bitDepthY ); iCurVal++)
     {
       iCheckSumLeft  += aiHistLeft [iCurVal];
@@ -1652,13 +1679,13 @@
 
 
-    while( iCurChangeVal <= g_uiIBDI_MAX )
+    while( iCurChangeVal < ( 1 << g_bitDepthY ) )
     {
       if ( iCumSumBase == iCumSumChange )
       {
-        aiConvLUT[iCurChangeVal] = Min(iCurBaseVal, g_uiIBDI_MAX);
+        aiConvLUT[iCurChangeVal] = std::min( iCurBaseVal,  ( 1 << g_bitDepthY ) - 1 );
         iCurBaseVal  ++;
         iCurChangeVal++;
         iCumSumChange += aiHistChange[iCurChangeVal];
-        if (iCurBaseVal <= g_uiIBDI_MAX )
+        if (iCurBaseVal <  ( 1 << g_bitDepthY ) )
         {
           iCumSumBase   += aiHistBase  [iCurBaseVal]  ;
@@ -1668,5 +1695,5 @@
       {
         iCurBaseVal++;
-        if (iCurBaseVal <= g_uiIBDI_MAX )
+        if (iCurBaseVal < ( 1 << g_bitDepthY ) )
         {
           iCumSumBase   += aiHistBase  [iCurBaseVal]  ;
@@ -1675,5 +1702,5 @@
       else if ( iCumSumBase > iCumSumChange)
       {
-        aiConvLUT[iCurChangeVal] = Min(iCurBaseVal, g_uiIBDI_MAX);
+        aiConvLUT[iCurChangeVal] = std::min(iCurBaseVal, ( 1 << g_bitDepthY )-1);
         iCurChangeVal++;
         iCumSumChange += aiHistChange  [iCurChangeVal]  ;
@@ -1884,4 +1911,5 @@
 Void TRenTop::temporalFilterVSRS( TComPicYuv* pcPicYuvVideoCur, TComPicYuv* pcPicYuvDepthCur, TComPicYuv* pcPicYuvVideoLast, TComPicYuv* pcPicYuvDepthLast, Bool bFirstFrame )
 {
+  AOF( g_bitDepthY == g_bitDepthC ); 
   Int iSADThres  = 100 ;  //threshold of sad in 4*4 block motion detection
 
@@ -1950,5 +1978,5 @@
             { //Weight: 0.75
               Int iFilt = (( (pcDepthLastDataBlk[iCurPosX] << 1 ) + pcDepthLastDataBlk[iCurPosX] + pcDepthCurDataBlk[iCurPosX] + 2 ) >> 2 );
-              assert( (iFilt >= 0) && (iFilt <=  g_uiIBDI_MAX) );
+              assert( (iFilt >= 0) && (iFilt <  ( 1 << g_bitDepthY ) ) );
               pcDepthCurDataBlk[iCurPosX] = pcDepthLastDataBlk[iCurPosX];
               pcDepthCurDataBlk[iCurPosX] = iFilt;
@@ -2221,2 +2249,4 @@
   if(m_aiBlkMoving         != NULL ) delete[] m_aiBlkMoving;
 }
+#endif // H_3D
+
Index: trunk/source/Lib/TLibRenderer/TRenTop.h
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenTop.h	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenTop.h	(revision 608)
@@ -38,4 +38,6 @@
 #include "../TLibCommon/CommonDef.h"
 #include "../TLibCommon/TComPicYuv.h"
+
+#if H_3D
 #include <list>
 #include <vector>
@@ -268,3 +270,4 @@
 };
 
+#endif // H_3D
 #endif //__TRENTOP__
